//
//  BuildController.m
//  ActionBuild
//
//  Created by Michael Murray on 12/6/09.
//  Copyright 2009 Wizaado. All rights reserved.
//

#import "BuildController.h"
#import "FlashTrace.h"

@implementation BuildController

@synthesize buildView;

- (IBAction) debugProject:(id)sender {
		
	//[mainTabVew selectTabViewItemWithIdentifier:@"messages"];
	
	
	if(compilerRunning) {
		[buildTask stopProcess];
		[buildTask release];
		buildTask = nil;
		
		return;
	} else {
		
		
		[self setStatus:@"Building"];
		
		if(buildTask != nil)
			[buildTask release];
		
		//buildTask = [[BuildTask alloc] initWithController:self andProjectDictionary:project.projectData];
		
		buildTask = [[BuildTask alloc] initWithController:self];
		
		if ([projectModel isSourceFileAnFLA]) {
			[buildTask buildUsingFlashCS4:project.projectFilePath projectData:project.projectData];
		} else {
			
			if(![projectModel isAIRProject]) {
				[buildTask buildUsingMXMLC:project.projectFilePath projectData:project.projectData];
			} else {
				[buildTask buildUsingAMXMLC];
			}
		}
		
		
		
	}
}

- (IBAction) runProject:(id)sender {
	
	[mainTabVew selectTabViewItemWithIdentifier:@"traces"];
	
	if(![projectModel isAIRProject]) {
		NSString *launchFileString = [[projectModel launchFile] retain];
		
		
		NSWorkspace *ws = [NSWorkspace sharedWorkspace];
		
		if([launchFileString hasPrefix:@"http://"]) {
			[ws openURL:[NSURL URLWithString:launchFileString]];
		} else {
			if([launchFileString isAbsolutePath]) {
				[ws openFile:launchFileString];
			} else {
				[ws openFile:[[projectModel projectFilePath] stringByAppendingFormat:@"/%@", launchFileString]];
			}
		}
		
		[launchFileString release];
	} else {
		NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
		NSString *adlPath = [[userDefaults objectForKey:@"flexSDKPath"] stringByAppendingPathComponent:@"bin/adl"];
		
		NSArray *args = [NSArray arrayWithObject:[[projectModel projectFilePath] stringByAppendingFormat:@"/%@", [projectModel launchFile]]];
		
		[NSTask launchedTaskWithLaunchPath:adlPath arguments:args];
	}	
}

#pragma mark -
#pragma mark Build Task Protocol

- (void) setOutput:(NSString *)text {
	
	//[messages clear];
	//[self appendOutput:text withLevel:@""];
	//[messages addMessage:text withType:@""];
	
	[[[outputText textStorage] mutableString] setString:text];
}
- (void) appendOutput:(NSString *)text{
	
	//[messages addMessage:text withType:level];
	
	[[[outputText textStorage] mutableString] appendString:text];
}

- (void) clearMessages {
	if(buildView)
		[buildView clearMessages];
}

- (void) addMessage:(OutputMessage *)message {
	if(buildView)
		[buildView addMessage:message];
}

- (void) setStatus:(NSString *)status {
	[statusLabel setStringValue:status];
}


- (void) launchProject {
	
}
// FCSH completed successfully
-(void) fcshSuccess {
	
	//NSString *filePath = [[[self fileURL] path] stringByDeletingLastPathComponent];
	//NSString *launchFile = [filePath stringByAppendingFormat:@"/%@", launch.option];
	
	//[fdb launch:launchFile withDebugger:debug];
}

- (void)processStarted {
	compilerRunning = YES;
}
- (void)processFinished {
	
	compilerRunning = NO;
	
	//[self showTraceTab:self];
	[self runProject:self];
	
	
}

- (void)processFinishedWithErrors {
	
	compilerRunning = NO;
	
	[mainTabVew selectTabViewItemWithIdentifier:@"errors"];
	
}

@end
