//
//  fcshTask.h
//  ActionBuild
//
//  Created by Michael Murray on 8/14/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "TableItem.h"
#import "CocoaOniguruma/OnigRegexp.h"
#import "OutputMessage.h";
//#import "ProjectController.h"

@class ProjectController;

@protocol BuildTaskController

- (void) setStatus:(NSString *)status;
- (void) setOutput:(NSString *)output;

- (void) clearMessages;
- (void) addMessage:(OutputMessage *)message;


- (void) appendOutput:(NSString *)output;
- (void) processStarted;
- (void) processFinished;
- (void) processFinishedWithErrors;

@end

typedef enum {mxmlc, flashcommand, adt} Compiler;

@interface BuildTask : NSObject {
	id <BuildTaskController>controller;
	
	Compiler compiler;
	
	ProjectController *project;
			
	NSTask *launchTask;
	NSMutableArray *compilerArguments;
	OnigRegexp *messageTypeRegexp;
	OnigRegexp *errorMessageRegexp;
		
	int argumentID;
	int compileErrors;
	int compileWarnings;
}

@property (readwrite, copy) NSMutableArray *compilerArguments;

//- (id)initWithController:(id <BuildTaskController>)aController andProjectModel:(ProjectController*)project;
- (id)initWithController:(id <BuildTaskController>)aController;
- (NSString *) createPathToFile:(NSString *)file;

- (void) buildUsingFlashCS4:(NSString*)directory projectData:(NSDictionary*)projectData;
- (void) buildUsingMXMLC:(NSString*)directory projectData:(NSDictionary*)pdata;
- (void) buildUsingAMXMLC;

- (NSArray *) makeMultipleArguments:(NSArray *)arrayOfTableItems;
- (NSArray *) makeMultipleArguments:(NSArray *)arrayOfTableItems withPrefix:(NSString *)prefix;

- (void) launchStop;
- (void) launchProcessStarted;
- (void) launchProcessEnded;
- (void) stopProcess;

@end
