//
//  FlashTrace.m
//  ActionBuild
//
//  Created by Michael Murray on 11/14/09.
//  Copyright 2009 Wizaado. All rights reserved.
//

#import "FlashTrace.h"


@implementation FlashTrace

- (void) awakeFromNib {
	pathToFlashLog = [[@"~/Library/Preferences/Macromedia/Flash Player/Logs/flashlog.txt" stringByExpandingTildeInPath] retain];
	
	[self launchTail];
}

- (void)dealloc {
    [self stopProcess];
	
    [launchTask release];
	[pathToFlashLog release];
	
    [super dealloc];
}

- (IBAction) clearOutput:(id)sender {
	[self clearOutput];
}

- (void) clearOutput {
	[traceOutput setString:@""];
}


- (void) appendOutput:(NSString *)text{
	
	
	//NSDictionary *font = [NSDictionary dictionaryWithObject:[NSFont boldSystemFontOfSize:15.0] forKey:NSFontAttributeName];
	//NSMutableAttributedString *aString = [[NSMutableAttributedString alloc] initWithString:text attributes:font];
	
	//[[traceOutput textStorage] appendAttributedString:aString];
	
	[[[traceOutput textStorage] mutableString] appendString:text];
	
	
		
	NSPoint newScrollOrigin;
	// assume that the scrollview is an existing variable
	
	if ([[scrollView documentView] isFlipped]) {
		newScrollOrigin=NSMakePoint(0.0,NSMaxY([[scrollView documentView] frame])
									
									-NSHeight([[scrollView contentView] bounds]));
	} else {
		newScrollOrigin=NSMakePoint(0.0,0.0);
	}
	[[scrollView documentView] scrollPoint:newScrollOrigin];
		
		
		
	
	//[aString release];
}	 


- (void) launchTail {
	
	[self clearOutput];
	
	if(launchTask) {
		[launchTask release];
		launchTask = nil;
	}
	
	launchTask = [[NSTask alloc] init];
	[launchTask setStandardOutput: [NSPipe pipe]];
	[launchTask setStandardError: [launchTask standardOutput]];
	
	NSMutableArray *args = [[NSMutableArray alloc] initWithCapacity:2];
	
	[args addObject: @"-f"];
	[args addObject:pathToFlashLog];
	
	[self launchProcessStarted];
	
	//NSString *launchPath = [[NSBundle mainBundle] pathForResource:@"socketserver" ofType:@"sh"];
	
	[launchTask setLaunchPath: @"/usr/bin/tail"];
	//[launchTask setLaunchPath: launchPath];
	[launchTask setArguments: args];
	
	[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(getData:) 
												 name: NSFileHandleReadCompletionNotification 
											   object: [[launchTask standardOutput] fileHandleForReading]];
	
	
	[[[launchTask standardOutput] fileHandleForReading] readInBackgroundAndNotify];
	
	// launch the task asynchronously
	[launchTask launch]; 
	
}


// If the task ends, there is no more data coming through the file handle even when the notification is
// sent, or the process object is released, then this method is called.
- (void) stopProcess
{

    NSData *data;
    
    // It is important to clean up after ourselves so that we don't leave potentially deallocated
    // objects as observers in the notification center; this can lead to crashes.
    [[NSNotificationCenter defaultCenter] removeObserver:self name:NSFileHandleReadCompletionNotification object: [[launchTask standardOutput] fileHandleForReading]];
    
    // Make sure the task has actually stopped!
    [launchTask terminate];
	
	while ((data = [[[launchTask standardOutput] fileHandleForReading] availableData]) && [data length])
	{
		[self appendOutput: [[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease]];
	}
	
	// we tell the controller that we finished, via the callback, and then blow away our connection
	// to the controller.  NSTasks are one-shot (not for reuse), so we might as well be too.
	[self launchProcessEnded];
}

// This method is called asynchronously when data is available from the task's file handle.
// We just pass the data along to the controller as an NSString.
- (void) getData: (NSNotification *)aNotification
{
    NSData *data = [[aNotification userInfo] objectForKey:NSFileHandleNotificationDataItem];
	
	if ([data length])  {
		
		NSString *stdOutput= [[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];		

		[self appendOutput:stdOutput];
		
        
    } else {
        // We're finished here
        [self stopProcess];
    }
    
    // we need to schedule the file handle go read more data in the background again.
    [[aNotification object] readInBackgroundAndNotify];  
}

- (void) launchStop {
	
}
- (void) launchProcessStarted {
	
}
- (void) launchProcessEnded {
	
}
@end