//
//  fcshTask.h
//  ActionBuild
//
//  Created by Michael Murray on 8/14/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol FlexCompilerShellController

- (void)setStatus:(NSString *)status;
- (void)setOutput:(NSString *)output;
- (void)appendOutput:(NSString *)output;
- (void)processStarted;
- (void)processFinished;
- (void)fcshSuccess;

@end

@interface FlexCompilerShellTask : NSObject {
	id <FlexCompilerShellController>controller;
	
	IBOutlet NSTextView *outputTextView;
	IBOutlet NSTextField *messageField; 
	
	NSPipe *pipe;
	NSPipe *inputPipe;
	NSFileHandle *inputHandler;
	
	NSPredicate *regextest;
	NSTask *launchTask;
	
	NSString *fcshCommand;
	
	int argumentID;
	int compileErrors;
}
- (id)initWithController:(id<FlexCompilerShellController>) aController;
-(void) build:(NSString*)command;
- (IBAction) quitFcsh:(id)sender;

- (void) compile;

- (void) launchStop;
- (void) launchProcessStarted;
- (void) launchProcessEnded;
- (void) setOutput:(NSString *)output;
- (void) appendOutput:(NSString *)output;

@end
