//
//  fcshTask.h
//  ActionBuild
//
//  Created by Michael Murray on 8/14/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol FlexDebuggerController

- (void)setStatus:(NSString *)status;
- (void)setOutput:(NSString *)output;
- (void)appendOutput:(NSString *)output;
- (void)processStarted;
- (void)processFinished;

@end

@interface FlexDebugger : NSObject {
	id <FlexDebuggerController>controller;
	
	IBOutlet NSTextView *outputTextView;
	IBOutlet NSTextField *messageField; 
	
	NSPipe *pipe;
	NSPipe *inputPipe;
	NSFileHandle *inputHandler;
	
	NSPredicate *regextest;
	NSTask *launchTask;
	
	NSString *fcshCommand;
	
	BOOL debuggerRunning;
	int argumentID;
	int compileErrors;
}
- (id)initWithController:(id<FlexDebuggerController>) aController;
-(void) launch:(NSString*)path withDebugger:(BOOL)debug;
- (void)quitFlexDebugger;

- (void) launchStop;
- (void) launchProcessStarted;
- (void) launchProcessEnded;

@end
