//
//  LaunchpadController.m
//  ActionBuild
//
//  Created by Mike Murray on 3/6/10.
//  Copyright 2010 Wizaado. All rights reserved.
//

#import "LaunchpadController.h"
#import "ProjectCollectionItem.h"

@implementation LaunchpadController

@synthesize openProjectKey;

-(void) setOpenProjectKey:(id)key {
	openProjectKey = key;
	
	NSLog(@" HELLOW??? %@", key);
}

- (void) dealloc {
	
	[openedProjects release];
	
	[super dealloc];
}

- (IBAction) showWindow:(id)sender {
	[super showWindow:sender];
	
	//- (void)setFrame:(NSRect)windowFrame display:(BOOL)displayViews
	
	//NSScreenSize
	
	//NSWindow *w = [self window];
	
	//[w animator]
	
	//NSRect originalFrame = [w frame];
	
	//[[w animator] setF
	
	//[w zoomOnFromRect:NSMakeRect(0, 0, 100, 100)];
	
	//[w setFrame:NSMakeRect(0, 0, 100, 100) display:YES];
	//[w setFrame:originalFrame display:YES animate:YES];
	
	[self addItemsToCollection];
}

- (void) awakeFromNib {
	
	openedProjects = [NSMutableArray new];
	
	[self addItemsToCollection];
}

- (void) addItemsToCollection {
	
	// Projects Collection View Data
	
	//[projects removeObjects:[projects arrangedObjects]];
	
	if([projects content]) {
		[[projects content] removeAllObjects];
	}
	
	NSArray *array = [[NSUserDefaults standardUserDefaults] objectForKey:@"Projects"];
	
	for(NSString *path in array) {
		[self addItemToCollection:path];
	}
	
	NSSortDescriptor *dateSort = [[NSSortDescriptor alloc] initWithKey:@"moddate" ascending:NO];
	
	[projects setContent:openedProjects];
	[projects setSortDescriptors:[NSArray arrayWithObject:dateSort]];
	[dateSort release];
	
	// Window
	[[self window] setTitle:@"ActionBuild - Launchpad"];
	[[self window] setContentBorderThickness:48.0 forEdge:NSMinYEdge];
}

- (void) addItemToCollection:(NSString*)path {
	
	if([[NSFileManager defaultManager] fileExistsAtPath:path]) {
	
		NSDictionary *attr = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:nil];
		
		NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
		[formatter setDateFormat:@"dd MMMM yyyy"];
		
		
		NSDate *date = [attr objectForKey:@"NSFileModificationDate"];
		NSString *displayDate = [formatter stringFromDate:date];
		NSString *name = [[path lastPathComponent] stringByDeletingPathExtension];
		NSImage *icon = [[NSWorkspace sharedWorkspace] iconForFile:path];
		[icon setSize:NSMakeSize(128, 128)];
		
		NSMutableDictionary *d = [NSMutableDictionary new];
		[d setObject:name forKey:@"name"];
		[d setObject:displayDate forKey:@"date"];
		[d setObject:icon forKey:@"icon"];
		[d setObject:path forKey:@"path"];
		[d setObject:date forKey:@"moddate"];
		
		//[projects addObject:d];
		
		[openedProjects addObject:d];
		
		[d release];
		[formatter release];
	} else {
		[self removeProjectFromDefaultsWithPath:path];
	}

}

- (NSMutableDictionary*) selectedProject {
	return [[projects selectedObjects] objectAtIndex:0];
}

- (void) removeSelectedProject {
	
	if([self selectedProject]) {
	
		NSAlert *alert = [[NSAlert new] autorelease];
		
		[alert addButtonWithTitle:@"OK"];
		[alert addButtonWithTitle:@"Cancel"];
		[alert setMessageText:@"Remove Project"];
		[alert setAlertStyle:NSWarningAlertStyle];
		[alert setInformativeText:@"Are you sure you want to remove the selected project?"];
		[alert beginSheetModalForWindow:[self window] modalDelegate:self didEndSelector:@selector(sheetDidEndShouldDelete:returnCode:contextInfo:) contextInfo:nil];
	}
	
}

- (void)sheetDidEndShouldDelete:(NSWindow *)sheet returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo {
	
	//NSLog(@"SELECTED ITEM TO DELETE: %@", [[projects selectedObjects] objectAtIndex:0]);
	
	if(returnCode == NSAlertFirstButtonReturn) {
		NSString *path = [[[projects selectedObjects] objectAtIndex:0] objectForKey:@"path"];		
		
		[self removeProjectFromDefaultsWithPath:path];
		
		[projects removeObject:[[projects selectedObjects] objectAtIndex:0]];
		
	}
}

- (BOOL) removeProjectFromDefaultsWithPath:(NSString*)path {
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSMutableArray *p = [[defaults objectForKey:@"Projects"] mutableCopy];
	
	if([p containsObject:path]) {			
		[p removeObject:path];
		[defaults setObject:p forKey:@"Projects"];
		
		return YES;
	}
	
	return NO;
}

- (void) selectProject:(id)sender {
	[[self window] makeFirstResponder:sender];
	
	NSLog(@"adasdasd");
	
}



- (void) doubleClick {
	
	NSString *path = [[[projects selectedObjects] objectAtIndex:0] objectForKey:@"path"];
	
	NSLog(@"Selected Item: %@", path);
	
	if([[NSWorkspace sharedWorkspace] openFile:path]) {
		
		NSMutableDictionary *attr = [NSMutableDictionary new];
		[attr setObject:[NSDate date] forKey:NSFileModificationDate];
		
		[[NSFileManager defaultManager] setAttributes:attr ofItemAtPath:path error:nil];
		
		[[self window] close];
	} else {
		NSAlert *alert = [[NSAlert new] autorelease];
		
		[alert addButtonWithTitle:@"OK"];
		[alert setMessageText:@"Project could not be opened" ];
		[alert setAlertStyle:NSWarningAlertStyle];
		[alert setInformativeText:@"The selected project could not be opened. Please ensure the file exists and that it has not been moved since launching this application."];
		[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
	}

}

- (IBAction)newProject:(id)sender { 
	
	[[self window] makeKeyAndOrderFront:sender];
	
	NSSavePanel *savePanel = [[NSSavePanel savePanel] retain];
	[savePanel setPrompt:@"Create Project"];
	[savePanel setAccessoryView:projectTemplateAccessoryView];
	
	//NSWindow *window = [[[self windowControllers] objectAtIndex:0] window];
	
	[savePanel beginSheetForDirectory:nil 
								 file:nil 
					   modalForWindow:[self window] 
						modalDelegate:self 
					   didEndSelector:@selector(savePanelDidEnd:returnCode:contextInfo:) 
						  contextInfo:NULL];
}
- (void)savePanelDidEnd:(NSSavePanel *)savePanel returnCode:(int)returnCode contextInfo:(void*)contextInfo {
	if(returnCode == NSOKButton) {
		
		NSString *loadedPath = [[savePanel filename] stringByAppendingPathExtension:@"abproj"];
		//NSData *data = [NSData dataWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"blankproject" ofType:@"abproj"]];
		
		NSString *destination = [[savePanel filename] stringByDeletingLastPathComponent];
		NSString *templateName;
		
		switch ([[templateType selectedItem] tag]) {
			case 0: templateName = @"Flash";	break;
			case 1: templateName = @"FlashCS4"; break;
			case 2: templateName = @"Flex";		break;
			case 3: templateName = @"AIR";		break;
			default:
				break;
		} 
		
		BOOL success = [self copyTemplate:templateName toPath:destination withProjectName:[loadedPath lastPathComponent]];
		
		if(success) {
			[[self window] close];
		}
		
		/*
		 BOOL didSave = [data writeToFile:loadedPath atomically:NO];
		 
		 if(didSave) {
		 [[NSWorkspace sharedWorkspace] openFile:loadedPath]; 
		 } else {
		 NSWindow *window = [[[self windowControllers] objectAtIndex:0] window];
		 
		 NSAlert *alert = [[NSAlert new] autorelease];
		 
		 [alert addButtonWithTitle:@"OK"];
		 [alert setMessageText:@"Project could not be created at path" ];
		 [alert setAlertStyle:NSWarningAlertStyle];
		 [alert setInformativeText:@"Project Creation Error"];
		 [alert beginSheetModalForWindow:window modalDelegate:self didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:nil];
		 }
		 */
	}
}

- (BOOL) copyTemplate:(NSString*)named toPath:(NSString*)toPath withProjectName:(NSString*)projectName {
	NSString *templatePath = [[[[NSBundle mainBundle] sharedSupportPath] stringByAppendingPathComponent:@"Templates"] retain];
	NSLog(@"All Templates Path: %@", templatePath);
	
	
	NSString *mainTemplate = [templatePath stringByAppendingPathComponent:named];
	NSLog(@"Path To Selected Template: %@", mainTemplate);
	
	NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:mainTemplate error:nil];
	NSLog(@"DirectoryEnum: %@", files);
	
	
	
	NSInteger tag;
	
	//NSLog(@"Destination Directory: %@", destinitaitonDir);
	
	BOOL success = [[NSWorkspace sharedWorkspace] performFileOperation:NSWorkspaceCopyOperation source:mainTemplate destination:toPath files:files tag:&tag];
	
	if (success) {
		NSLog(@"Copy operation Success");
		
		NSString *oldProjectFile = [toPath stringByAppendingPathComponent:@"PROJECT.abproj"];
		NSString *newProjectFile = [toPath stringByAppendingPathComponent:projectName];
		
		BOOL projectRenameSuccess = [[NSFileManager defaultManager] moveItemAtPath:oldProjectFile toPath:newProjectFile error:nil];
		
		if(projectRenameSuccess) {
			[[NSWorkspace sharedWorkspace] openFile:newProjectFile]; 
		} else {			
			NSAlert *alert = [[NSAlert new] autorelease];
			
			[alert addButtonWithTitle:@"OK"];
			[alert setMessageText:@"Project could not be loaded" ];
			[alert setAlertStyle:NSWarningAlertStyle];
			[alert setInformativeText:@"Project Creation Error"];
			[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
			
			return NO;
		}
	} else {		
		NSAlert *alert = [[NSAlert new] autorelease];
		
		[alert addButtonWithTitle:@"OK"];
		[alert setMessageText:@"Project could not be created at path" ];
		[alert setAlertStyle:NSWarningAlertStyle];
		[alert setInformativeText:@"Project Creation Error"];
		[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
		
		return NO;
	}
	
	return YES;
	
}

- (IBAction) revealInFinder:(id)sender {
	NSWorkspace *ws = [NSWorkspace sharedWorkspace];
	
	[ws selectFile:[[self selectedProject] objectForKey:@"path"] inFileViewerRootedAtPath:nil];
}

- (IBAction) deleteProject:(id)sender {
	[self removeSelectedProject];
}

@end
