//
//  MenuItem.m
//  ActionBuild
//
//  Created by Michael Murray on 12/22/09.
//  Copyright 2009 Wizaado. All rights reserved.
//

#import "MenuItem.h"


@implementation MenuItem

#define IsALeafNode ((id)-1)

@synthesize title;
@synthesize iconName;
@synthesize tag;

- (id)init {
	self = [super init];
	
	[self initWithRepresentedObject:self];
	
	return self;
}

/*
- (void)setObjectValue:(MenuItem*)value {
	self = value;
}
- (MenuItem*)objectValue {
	return self;
}*/

-(void) dealloc {
	self.title = nil;
	self.iconName = nil;
	self.tag = nil;
	
	[super dealloc];
}

- (id)copyWithZone:(NSZone *)zone {
	
	//NSLog(@"MenuItem Zone: %@", [self zone]);
	
	MenuItem *mi = [[MenuItem allocWithZone:zone] init];
	mi.title = self.title;
	mi.iconName = self.iconName;
	
	return mi;
}

+ (MenuItem*)initWithTitle:(NSString*)itemTitle {
	
	MenuItem *mi = [[MenuItem new] autorelease];
	mi.title = itemTitle;
	mi.iconName = @"";
	mi.tag = @"";
	
	
	[mi initWithRepresentedObject:mi];
		
	return mi;
}

+ (MenuItem*)initWithTitle:(NSString*)itemTitle withIcon:(NSString*)theIcon {
	
	MenuItem *mi = [MenuItem new];
	mi.title = itemTitle;
	mi.iconName = theIcon;
	
	return mi;
}


- (BOOL)isHeading {
    return [[self childNodes] count] == 0;
}


@end
