//
//  MyDocument.h
//  ActionBuild
//
//  Created by Michael Murray on 7/8/09.
//  Copyright __MyCompanyName__ 2009 . All rights reserved.
//


#import <Cocoa/Cocoa.h>
#import <BWToolkitFramework/BWToolkitFramework.h>
#import "BuildController.h";
#import "MenuOutlineView.h";
#import "BuildViewController.h"
#import "RunViewController.h"
#import "MainTabView.h"
#import "ProjectController.h"

@interface MyDocument : NSDocument
{	
	// Save panel Accessory View
	NSView *projectTemplateAccessoryView;
	NSPopUpButton *templateType;
	
	IBOutlet NSSegmentedControl *viewSelector;
	IBOutlet BuildController *buildController;
	IBOutlet MenuOutlineView *theMenu;
	IBOutlet NSOutlineView *projectSettings;
	IBOutlet NSArrayController *settingsController;
	IBOutlet NSDictionaryController *optionsController;
	IBOutlet BWSheetController *projectOptionsSheet;
	IBOutlet BWTransparentCheckbox *debugCheckbox;	
	IBOutlet NSTreeController *settingsTree;
	IBOutlet NSOutlineView *settingOutlineView;
	IBOutlet NSDictionaryController *projectDictController;
	
	NSData *dataFromFile;
	NSMutableDictionary *projectData;
	
	MainTabView *mainTabView;
	BuildViewController *buildView;
	RunViewController *runView;
	ProjectController *project;
}

@property(nonatomic, retain) IBOutlet MainTabView *mainTabView;
@property(nonatomic, retain) IBOutlet ProjectController *project;
@property(nonatomic, retain) IBOutlet NSView *projectTemplateAccessoryView;
@property(nonatomic, retain) IBOutlet NSPopUpButton *templateType;


- (IBAction)closeSettingsSheetAndSave:(id)sender;
- (IBAction)newProject:(id)sender;
- (IBAction) openOptionsSheet:(id)sender;
- (IBAction) reloadPreview:(id)sender;
- (IBAction) stopPreview:(id)sender;
- (IBAction) showBuildView:(id)sender;
- (IBAction) showRunView:(id)sender;
- (IBAction) buildProject:(id)sender;
- (IBAction) runProject:(id)sender;

- (BOOL) copyTemplate:(NSString*)named toPath:(NSString*)toPath withProjectName:(NSString*)projectName;

@end
