//
//  MyDocument.m
//  ActionBuild
//
//  Created by Michael Murray on 7/8/09.
//  Copyright __MyCompanyName__ 2009 . All rights reserved.
//

#import "MyDocument.h"

@implementation MyDocument

@synthesize mainTabView;
@synthesize project;
@synthesize projectTemplateAccessoryView;
@synthesize templateType;

- (id)init
{
    self = [super init];
    if (self) {}
    return self;
}

-(void) dealloc {
	[super dealloc];
}
- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void) awakeFromNib {
	[mainTabView setAutoresizesSubviews:YES];
	[mainTabView setTabViewType: NSNoTabsNoBorder];
	
	buildView = [BuildViewController new];
	runView = [RunViewController new];
	
	[mainTabView addSubview:buildView.view withIdentifier:@"build"];
	[mainTabView addSubview:runView.view withIdentifier:@"run"];
	
	buildController.buildView = buildView;
	
	project.mainTabView = mainTabView;
	project.buildView = buildView;
	project.runView = runView;
}


- (void)windowControllerDidLoadNib:(NSWindowController *) aController {
    [super windowControllerDidLoadNib:aController];
	[project projectWithContentsOfFile:[[self fileURL] path]];
	
}

- (IBAction)newProject:(id)sender { 
	NSSavePanel *savePanel = [[NSSavePanel savePanel] retain];
	[savePanel setPrompt:@"Create Project"];
	[savePanel setAccessoryView:projectTemplateAccessoryView];
	
	NSWindow *window = [[[self windowControllers] objectAtIndex:0] window];
	
	[savePanel beginSheetForDirectory:nil 
											  file:nil 
									modalForWindow:window 
									 modalDelegate:self 
									didEndSelector:@selector(savePanelDidEnd:returnCode:contextInfo:) 
									   contextInfo:NULL];
}
- (void)savePanelDidEnd:(NSSavePanel *)savePanel returnCode:(int)returnCode contextInfo:(void*)contextInfo {
	if(returnCode == NSOKButton) {
	
		NSString *loadedPath = [[savePanel filename] stringByAppendingPathExtension:@"abproj"];
		//NSData *data = [NSData dataWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"blankproject" ofType:@"abproj"]];
				
		NSString *destination = [[savePanel filename] stringByDeletingLastPathComponent];
		NSString *templateName;
		
		switch ([[templateType selectedItem] tag]) {
			case 0: templateName = @"Flash";	break;
			case 1: templateName = @"FlashCS4"; break;
			case 2: templateName = @"Flex";		break;
			case 3: templateName = @"AIR";		break;
			default:
				break;
		} 
		
		[self copyTemplate:templateName toPath:destination withProjectName:[loadedPath lastPathComponent]];
		
		/*
		BOOL didSave = [data writeToFile:loadedPath atomically:NO];
		
		if(didSave) {
			[[NSWorkspace sharedWorkspace] openFile:loadedPath]; 
		} else {
			NSWindow *window = [[[self windowControllers] objectAtIndex:0] window];
			
			NSAlert *alert = [[NSAlert new] autorelease];
			
			[alert addButtonWithTitle:@"OK"];
			[alert setMessageText:@"Project could not be created at path" ];
			[alert setAlertStyle:NSWarningAlertStyle];
			[alert setInformativeText:@"Project Creation Error"];
			[alert beginSheetModalForWindow:window modalDelegate:self didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:nil];
		}
		 */
	}
}

- (BOOL) copyTemplate:(NSString*)named toPath:(NSString*)toPath withProjectName:(NSString*)projectName {
	NSString *templatePath = [[[[NSBundle mainBundle] sharedSupportPath] stringByAppendingPathComponent:@"Templates"] retain];
	NSLog(@"All Templates Path: %@", templatePath);
	
	
	NSString *mainTemplate = [templatePath stringByAppendingPathComponent:named];
	NSLog(@"Path To Selected Template: %@", mainTemplate);
	
	NSArray *files = [[NSFileManager defaultManager] contentsOfDirectoryAtPath:mainTemplate error:nil];
	NSLog(@"DirectoryEnum: %@", files);
	
	
	
	NSInteger tag;
	
	//NSLog(@"Destination Directory: %@", destinitaitonDir);
	
	BOOL success = [[NSWorkspace sharedWorkspace] performFileOperation:NSWorkspaceCopyOperation source:mainTemplate destination:toPath files:files tag:&tag];
	
	if (success) {
		NSLog(@"Copy operation Success");
		
		NSString *oldProjectFile = [toPath stringByAppendingPathComponent:@"PROJECT.abproj"];
		NSString *newProjectFile = [toPath stringByAppendingPathComponent:projectName];
		
		BOOL projectRenameSuccess = [[NSFileManager defaultManager] moveItemAtPath:oldProjectFile toPath:newProjectFile error:nil];
		
		if(projectRenameSuccess) {
			[[NSWorkspace sharedWorkspace] openFile:newProjectFile]; 
		} else {			
			NSAlert *alert = [[NSAlert new] autorelease];
			
			[alert addButtonWithTitle:@"OK"];
			[alert setMessageText:@"Project could not be loaded" ];
			[alert setAlertStyle:NSWarningAlertStyle];
			[alert setInformativeText:@"Project Creation Error"];
			[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
		}
	} else {		
		NSAlert *alert = [[NSAlert new] autorelease];
		
		[alert addButtonWithTitle:@"OK"];
		[alert setMessageText:@"Project could not be created at path" ];
		[alert setAlertStyle:NSWarningAlertStyle];
		[alert setInformativeText:@"Project Creation Error"];
		[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:nil contextInfo:nil];
	}

	
}


- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError {
    if ( outError != NULL ) {
		*outError = [NSError errorWithDomain:NSOSStatusErrorDomain code:unimpErr userInfo:NULL];
	}
			
}

- (BOOL)readFromFileWrapper:(NSFileWrapper *)fileWrapper ofType:(NSString *)typeName error:(NSError **)outError {
	if ([fileWrapper isRegularFile]) {
		projectData = [NSDictionary dictionaryWithContentsOfURL:[self fileURL]];
		return YES;
	}
	return NO;
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError {
	dataFromFile = [data retain];
    if ( outError != NULL ) {
		*outError = [NSError errorWithDomain:NSOSStatusErrorDomain code:unimpErr userInfo:NULL];
	}
    return YES;
}

#pragma mark -
#pragma mark Actions

- (IBAction) closeSettingsSheetAndSave:(id)sender {
	
	if([project settingsAreValid]) {
		[project saveProject];
		[projectOptionsSheet closeSheet:sender];
	}
}

- (IBAction) openOptionsSheet:(id)sender {
	[projectOptionsSheet openSheet:sender];
}

- (IBAction) clearTraces:(id)sender {
	[buildView clearTraces:sender];
}

- (IBAction) reloadPreview:(id)sender {
	[runView reload:sender]; 
}

- (IBAction) stopPreview:(id)sender {
	[runView showDebugger];
}

- (IBAction) showBuildView:(id)sender {
	[mainTabView selectTabViewItemWithIdentifier:@"build"];
}

- (IBAction) showRunView:(id)sender {
	[mainTabView selectTabViewItemWithIdentifier:@"run"];
}

- (IBAction) buildProject:(id)sender {
	[project debugProject:sender];
}

- (IBAction) runProject:(id)sender {
	[project runProject:sender];
}

#pragma mark -
#pragma mark Delegates (Move someday)

- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem {
	[viewSelector setSelectedSegment:[tabView indexOfTabViewItem:tabViewItem]];
}

@end
