//
//  OutputMessageTableView.m
//  ActionBuild
//
//  Created by Michael Murray on 10/25/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "OutputMessageTableView.h"


@implementation OutputMessageTableView

- (void)drawRow:(NSInteger)row clipRect:(NSRect)clipRect;
{
	
	
	NSColor *color = [(OutputMessageDataSource*)[self dataSource] tableView:self backgroundColorForRow:row];
	
	// ignore any background color if the row is selected
	if (color && [self isRowSelected:row] == NO) {
		
		//NSLog(@"%@ %i", @"Color For Row", row);
		
		[NSGraphicsContext saveGraphicsState];
		NSRectClip(clipRect);
		NSRect rowRect = [self rectOfRow:row];
		
		// draw over the alternating row color
		[[NSColor whiteColor] setFill];
		NSRectFill(NSIntersectionRect(rowRect, clipRect));
		
		// draw with rounded end caps
		CGFloat radius = NSHeight(rowRect) / 2.0;
		NSBezierPath *p = [NSBezierPath bezierPathWithRoundedRect:NSInsetRect(rowRect, 1.0, 0.0) xRadius:radius yRadius:radius];
		
		[color setFill];
		/*
		NSArray *colors = [NSArray arrayWithObjects: 
						   [NSColor colorWithCalibratedRed:0.66 green:0 blue:0 alpha:1],									
						   [NSColor colorWithCalibratedRed:0.167 green:0 blue:0 alpha:1], nil
						   ];
		
		NSGradient *gradient = [[[NSGradient alloc] initWithColors: colors] autorelease];
		
		[gradient drawInBezierPath:p angle:90];
		  */
		[p fill];
		[NSGraphicsContext restoreGraphicsState];
		
		
	}
	// draw cells on top of the new row background
	[super drawRow:row clipRect:clipRect];
}



@end
