//
//  PreferencesController.m
//  ActionBuild
//
//  Created by Michael Murray on 11/14/09.
//  Copyright 2009 Wizaado. All rights reserved.
//

#import "PreferencesController.h"


@implementation PreferencesController

- (IBAction) browseForFlexSDK:(id)sender {
	
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	[openPanel setCanChooseFiles:NO];
	[openPanel setCanChooseDirectories:YES];
	
	if([openPanel runModalForDirectory:nil file:nil] == NSOKButton) {
		
		NSString *loadedPath = [[[openPanel filenames] objectAtIndex:0] retain];
		NSFileManager *manager = [NSFileManager defaultManager];
		BOOL exists = [manager fileExistsAtPath:[loadedPath stringByAppendingString:@"/bin/mxmlc"]];
		
		if(exists) {
			
			// save
			NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
			[userDefaults setObject:loadedPath forKey:@"flexSDKPath"];
			
			// And display
			[flexSDKField setStringValue:loadedPath];
			
		} else {
			
			NSAlert *alert = [[NSAlert new] autorelease];
			
			[alert addButtonWithTitle:@"OK"];
			[alert setMessageText:@"Not Flex SDK" ];
			[alert setInformativeText:[NSString stringWithFormat:@"The directory (%@) is not a valid Flex SDK path.", loadedPath]];
			[alert setAlertStyle:NSWarningAlertStyle];
			
			[alert beginSheetModalForWindow:nil modalDelegate:self didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:nil];
		}
	}
}

- (void)alertDidEnd:(NSAlert *)alert returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo {
	// Empty!!
}

- (IBAction) enableTracing:(id)sender {
	NSString *mmcfg = @"ErrorReportingEnable=1\nTraceOutputFileEnable=1";
	NSError *error = nil;
	
	[mmcfg writeToFile:[@"~/mm.cfg" stringByExpandingTildeInPath] atomically:NO encoding:NSUTF8StringEncoding error:&error];
	NSLog(@"%@", error);
}

@end
