//
//  ProjectCollectionItem.m
//  CollectionView
//
//  Created by Mike Murray on 3/6/10.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import "ProjectCollectionItem.h"
#import "ProjectItemView.h"

@implementation ProjectCollectionItem

@synthesize name;
@synthesize date;
@synthesize projectPath;
@synthesize icon;
@synthesize delegate;

- (id) initWithPath:(NSString*)path {
	
	self = [super init];
	
	NSDictionary *attr = [[NSFileManager defaultManager] attributesOfItemAtPath:path error:nil];
	
	NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
	[formatter setDateFormat:@"dd MMMM yyyy"];
	
	self.date = [formatter stringFromDate:[attr objectForKey:@"NSFileModificationDate"]];
	self.name = [[path lastPathComponent] stringByDeletingPathExtension];
	self.icon = [[NSWorkspace sharedWorkspace] iconForFile:path];
	[self.icon setSize:NSMakeSize(128, 128)];
	self.projectPath = path;
	
	return self;
}


- (void) setSelected:(BOOL)flag {
	
	[super setSelected:flag];
	
	ProjectItemView *view = (ProjectItemView*)[self view];
	[view setSelected:flag];
}

- (void) awakeFromNib {
}

@end
