//
//  ProjectCollectionView.m
//  CollectionView
//
//  Created by Mike Murray on 3/7/10.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import "ProjectCollectionView.h"


@implementation ProjectCollectionView

@synthesize delegate;

//Observer for the collection view array controller selection: "selectionIndexes"
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
    if([keyPath isEqualTo:@"selectionIndexes"])
    {
        //True if in the array controller of the collection view really exists at least a selected object
        if([[ac selectedObjects] count] > 0)
        {
            //NSLog(@"Selected objects: %@", [self newItemForRepresentedObject:[[ac selectedObjects] objectAtIndex:0]]);
			//NSLog(@"--------------------------------------------");
			//NSLog(@"Selected objects: %@", [[ac selectedObjects] objectAtIndex:0]);
        }
        else
        {
            //NSLog(@"Observer called but no objects where selected.");
        }
    }
}

-(void)awakeFromNib
{
    //Add a new observer to the array controller of the collection view
    [ac addObserver:self forKeyPath:@"selectionIndexes" options:NSKeyValueObservingOptionNew context:nil];
}

- (void)dealloc
{
    //Remove the collection view array controller selectionIndexes observer
    [ac removeObserver:self forKeyPath:@"selectionIndexes"];
    [super dealloc];
}

- (void) keyDown:(NSEvent *)theEvent {
	
	NSLog(@"KEY DOWN");
	
	if ([theEvent modifierFlags] & NSCommandKeyMask) {
				
		NSString *characters;
		characters = [theEvent characters];
		
		unichar character;
		character = [characters characterAtIndex: 0];
		
		
		if(character == NSDeleteCharacter) {
			
			 if([self.delegate respondsToSelector:@selector(removeSelectedProject)]) {
				 [self.delegate removeSelectedProject];
			 }
			NSLog(@"CMD KEY DOWN");
		}
	} else {
		[super keyDown:theEvent];
	}
	
}

@end
