//
//  ProjectItemView.m
//  CollectionView
//
//  Created by Mike Murray on 3/7/10.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import "ProjectItemView.h"
#import "ProjectCollectionItem.h"

@implementation ProjectItemView

@synthesize projectPath;
@synthesize delegate;
//@synthesize highlightBox;

- (void) mouseDown:(NSEvent *)theEvent {
	if([theEvent clickCount] >= 2) {		
		if([self.delegate respondsToSelector:@selector(doubleClick)]) {
			[self.delegate doubleClick];
		}
		
	} else {
		
		[super mouseDown:theEvent];
	}
	
}



- (BOOL)acceptsFirstResponder {
	return YES;
}


- (void) setSelected:(BOOL)flag {
	isSelected = flag;
	[self setNeedsDisplay:YES];
}

- (void) drawRect:(NSRect)dirtyRect {
	
	
	NSColor *bgColor;
	
	if(isSelected) {
		bgColor = [NSColor alternateSelectedControlColor];
	} else {
		bgColor = [NSColor controlBackgroundColor];
	}
	
	
	NSRect rect = NSMakeRect(27, 49, 132, 132);
	NSBezierPath *b = [NSBezierPath bezierPathWithRoundedRect:rect xRadius:8.0 yRadius:8.0];
	
	[bgColor setFill];
	[b fill];
	
}

-(void) awakeFromNib {
}

@end
